--- app_authenticate.c.orig	2005-06-07 02:39:31.000000000 +0400
+++ app_authenticate.c	2005-07-21 18:04:25.322640398 +0400
@@ -46,6 +46,10 @@
 "of the following letters:\n"
 "     a - Set account code to the password that is entered\n"
 "     d - Interpret path as database key, not literal file\n"
+"     m - Interpret path as a file which contains a list of\n"
+"         account codes and password hashes delimited with ':'\n"
+"         one per line. When password matched, corresponding\n"
+"         account code will be set\n"
 "     j - Support jumping to n+101\n"
 "     r - Remove database key upon successful entry (valid with 'd' only)\n"
 "\n"
@@ -115,12 +119,29 @@
 				f = fopen(password, "r");
 				if (f) {
 					char buf[256] = "";
+					char md5passwd[16] = "";
+					char *md5secret;
 					while(!feof(f)) {
 						fgets(buf, sizeof(buf), f);
 						if (!feof(f) && !ast_strlen_zero(buf)) {
 							buf[strlen(buf) - 1] = '\0';
-							if (!ast_strlen_zero(buf) && !strcmp(passwd, buf))
-								break;
+							if (!ast_strlen_zero(buf)) {  
+								if(strchr(opts,'m')) {
+									md5secret = strchr(buf, ':');
+									if(md5secret == NULL)
+										continue;
+									*md5secret = '\0';
+									md5secret++;
+									ast_md5_hash(md5passwd, passwd);
+									if(!ast_strlen_zero(buf) && !strcmp(md5passwd, md5secret)) {
+										ast_cdr_setaccount(chan, buf);
+										break;
+									}
+								} else {
+									if(!strcmp(passwd, buf))
+										break;
+								}
+							}
 						}
 					}
 					fclose(f);
@@ -147,7 +168,7 @@
 			chan->priority+=100;
 			res = 0;
 		} else {
-			if (!ast_streamfile(chan, "vm-goodbye", chan->language))
+			if (!ast_streamfile(chan, "auth-goodbye", chan->language))
 				res = ast_waitstream(chan, "");
 			res = -1;
 		}
